You cannot select more than 25 topics Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.

374 lines
11 KiB
Bash

#!/bin/sh
. /lib/functions.sh
. /lib/functions/system.sh
# initialize defaults
RAMFS_COPY_BIN="" # extra programs for temporary ramfs root
RAMFS_COPY_DATA="" # extra data files
export MTD_CONFIG_ARGS=""
export INTERACTIVE=0
export VERBOSE=1
export SAVE_CONFIG=1
export SAVE_OVERLAY=0
export DELAY=
export CONF_IMAGE=
export CONF_BACKUP_LIST=0
export CONF_BACKUP=
export CONF_RESTORE=
export NEED_IMAGE=
export HELP=0
export FORCE=0
export TEST=0
export PACKAGE_LIST=0
# parse options
while [ -n "$1" ]; do
case "$1" in
-i) export INTERACTIVE=1;;
-d) export DELAY="$2"; shift;;
-v) export VERBOSE="$(($VERBOSE + 1))";;
-q) export VERBOSE="$(($VERBOSE - 1))";;
-n) export SAVE_CONFIG=0;;
-c) export SAVE_OVERLAY=1;;
-b|--create-backup) export CONF_BACKUP="$2" NEED_IMAGE=1; shift;;
-r|--restore-backup) export CONF_RESTORE="$2" NEED_IMAGE=1; shift;;
-l|--list-backup) export CONF_BACKUP_LIST=1; break;;
-p|--list-packages) export PACKAGE_LIST=1; break;;
-f) export CONF_IMAGE="$2"; shift;;
-F|--force) export FORCE=1;;
-T|--test) export TEST=1;;
-h|--help) export HELP=1; break;;
-*)
echo "Invalid option: $1"
exit 1
;;
*) break;;
esac
shift;
done
export CONFFILES=/tmp/sysupgrade.conffiles
export CONF_TAR=/tmp/sysupgrade.tgz
export ARGV="$*"
export ARGC="$#"
[ -z "$ARGV" -a -z "$NEED_IMAGE" -o $HELP -gt 0 ] && {
cat <<EOF
Usage: $0 [<upgrade-option>...] [nand] <image file or URL>
$0 [-q] [-i] <backup-command> <file>
upgrade-option:
-d <delay> add a delay before rebooting
-f <config> restore configuration from .tar.gz (file or url)
-i interactive mode
-c attempt to preserve all changed files in /etc/
-n do not save configuration over reflash
-T | --test
Verify image and config .tar.gz but do not actually flash.
-F | --force
Flash image even if image checks fail, this is dangerous!
-q less verbose
-v more verbose
-h | --help display this help
nand NAND base update mechanis, expects .tar with CONTROL, kernel, rootfs
(devolo modified)
needs to be passed as first non-option directly before file name
backup-command:
-b | --create-backup <file>
create .tar.gz of files specified in sysupgrade.conf
then exit. Does not flash an image. If file is '-',
i.e. stdout, verbosity is set to 0 (i.e. quiet).
-r | --restore-backup <file>
restore a .tar.gz created with sysupgrade -b
then exit. Does not flash an image. If file is '-',
the archive is read from stdin.
-l | --list-backup
list the files that would be backed up when calling
sysupgrade -b. Does not create a backup file.
-p | --list-packages
list the packages that were installed by the user.
Does not create a backup file.
EOF
exit 1
}
[ -n "$ARGV" -a -n "$NEED_IMAGE" ] && {
cat <<-EOF
-b|--create-backup and -r|--restore-backup do not perform a firmware upgrade.
Do not specify both -b|-r and a firmware image.
EOF
exit 1
}
# prevent messages from clobbering the tarball when using stdout
[ "$CONF_BACKUP" = "-" ] && export VERBOSE=0
# delos extension
dump_installed_packages() {
# print a list of installed packages which are not in the original image
local PACKAGE SEP VERSION TAG FLAGS FLAG
opkg list_installed | while read PACKAGE SEP VERSION; do
# installed in rootfs image?
[ -e "/rom/usr/lib/opkg/info/$PACKAGE.control" ] && continue
# not installed as dependency? (has flag 'ok' instead of 'user')
opkg status $PACKAGE | grep '^Status:' | while read TAG FLAGS; do
for FLAG in $FLAGS; do
[ "$FLAG" = "user" ] && echo $PACKAGE && break;
done
done
done
# and packages that failed to install in the current image
[ -e /etc/sysupgrade.packages-install-fail.conf ] && {
for PACKAGE in $(cat /etc/sysupgrade.packages-install-fail.conf); do
[ -z "$(opkg list-installed $PACKAGE)" ] && echo $PACKAGE
done
}
}
add_installed_packages() {
dump_installed_packages >/tmp/sysupgrade.packages-installed.conf
rm -f /etc/sysupgrade.packages-installed.conf
[ -s /tmp/sysupgrade.packages-installed.conf ] && {
mv /tmp/sysupgrade.packages-installed.conf /etc
echo /etc/sysupgrade.packages-installed.conf
}
}
# devolo: only include config files which are dynamic in delos
DVL_CONFIGFILE_WHITELIST=" \
-e ^/etc$ \
-e ^/etc/uhttpd.crt$ \
-e ^/etc/uhttpd.key$ \
-e ^/etc/dropbear$ \
-e ^/etc/dropbear/dropbear_dss_host_key$ \
-e ^/etc/dropbear/dropbear_rsa_host_key$ \
-e ^/etc/shadow$ \
-e ^/etc/config$ \
-e ^/etc/config/ \
-e ^/lib$ \
-e ^/lib/firmware$ \
-e ^/lib/firmware/plc$ \
-e ^/lib/firmware/plc/user.pib$ \
-e ^/lib/firmware/plc/user.pib.tmp$ \
-e ^/lib/firmware/plc/user.nvm$ \
-e ^/lib/firmware/plc/user.nvm.tmp$ \
"
sanitize_conffile_list() {
local filelist="$1"
mv -f "$filelist" "$filelist.tmp"
grep $DVL_CONFIGFILE_WHITELIST "$filelist.tmp" > "$filelist"
rm -f "$filelist.tmp"
}
sanitize_config_tarball() {
local tarfile="$1"
local tmpdir="/tmp/sysupgrade_sanitize_config_tarball"
rm -rf "$tmpdir"; mkdir -p "$tmpdir"
tar -C "$tmpdir" -xzf "$tarfile"
( cd "$tmpdir"; for F in $(find .); do
F="${F#.}"
[ -n "$F" ] && [ -z $(echo "$F" | grep $DVL_CONFIGFILE_WHITELIST) ] && rm -rf ".$F"
done; find . ! -type d > /tmp/sysupgrade_include.txt; tar -czf "$tarfile" -T /tmp/sysupgrade_include.txt; )
rm -rf "$tmpdir" /tmp/sysupgrade_include.txt
}
# /delos extension
add_uci_conffiles() {
local file="$1"
( find $(sed -ne '/^[[:space:]]*$/d; /^#/d; p' \
/etc/sysupgrade.conf /lib/upgrade/keep.d/* 2>/dev/null) \
-type f -o -type l 2>/dev/null;
opkg list-changed-conffiles ) | sort -u > "$file"
add_installed_packages >> "$file"
return 0
}
add_overlayfiles() {
local file="$1"
if [ -d /overlay/upper ]; then
local overlaydir="/overlay/upper"
else
local overlaydir="/overlay"
fi
find $overlaydir/etc/ -type f -o -type l | sed \
-e 's,^/overlay/,/,' \
-e '\,/META_[a-zA-Z0-9]*$,d' \
-e '\,/functions.sh$,d' \
-e '\,/[^/]*-opkg$,d' \
> "$file"
return 0
}
# hooks
sysupgrade_image_check="platform_check_image"
[ $SAVE_OVERLAY = 0 -o ! -d /overlay/etc ] && \
sysupgrade_init_conffiles="add_uci_conffiles" || \
sysupgrade_init_conffiles="add_overlayfiles"
include /lib/upgrade
[ "$ARGC" -ge 2 ] && {
(cat /tmp/sysinfo/model | grep "IPQ" ||
cat /tmp/sysinfo/model | grep "ew7479cap" ||
cat /tmp/sysinfo/model | grep "dlan2-2400-ac" ||
cat /tmp/sysinfo/model | grep "ap-dk07.1-c1") && shift && ARGV=$1
}
do_save_conffiles() {
local conf_tar="${1:-$CONF_TAR}"
[ -z "$(rootfs_type)" ] && {
echo "Cannot save config while running from ramdisk."
ask_bool 0 "Abort" && exit
return 0
}
run_hooks "$CONFFILES" $sysupgrade_init_conffiles
[ -n "$CONF_BACKUP" ] && sanitize_conffile_list "$CONFFILES"
ask_bool 0 "Edit config file list" && vi "$CONFFILES"
v "Saving config files..."
[ "$VERBOSE" -gt 1 ] && TAR_V="v" || TAR_V=""
tar c${TAR_V}zf "$conf_tar" -T "$CONFFILES" 2>/dev/null
rm -f "$CONFFILES"
rm -f /etc/sysupgrade.packages-installed.conf
}
if [ $CONF_BACKUP_LIST -eq 1 ]; then
run_hooks "$CONFFILES" $sysupgrade_init_conffiles
sanitize_conffile_list "$CONFFILES"
cat "$CONFFILES"
rm -f "$CONFFILES"
rm -f /etc/sysupgrade.packages-installed.conf
exit 0
fi
if [ $PACKAGE_LIST -eq 1 ]; then
dump_installed_packages
exit 0
fi
if [ -n "$CONF_BACKUP" ]; then
do_save_conffiles "$CONF_BACKUP"
exit $?
fi
if [ -n "$CONF_RESTORE" ]; then
if [ "$CONF_RESTORE" != "-" ] && [ ! -f "$CONF_RESTORE" ]; then
echo "Backup archive '$CONF_RESTORE' not found."
exit 1
fi
type platform_check_config >/dev/null 2>/dev/null && [ "$CONF_RESTORE" != "-" ] && {
platform_check_config "$CONF_RESTORE" || exit 1
}
sanitize_config_tarball "$CONF_RESTORE"
[ "$VERBOSE" -gt 1 ] && TAR_V="v" || TAR_V=""
tar -C / -x${TAR_V}zf "$CONF_RESTORE"
exit $?
fi
# original sysupgrade nand did not even try to save config files, even though nand.sh worked with sysupgrade.tgz
if [ "$1" = "nand" ]; then
if ! nand_platform_check "$@"; then
if [ $FORCE -eq 1 ]; then
echo 'Image check (nand) failed, but --force given - will update anyway!'
else
echo "Image check (nand) failed"
exit 1
fi
fi
if [ $TEST -eq 1 ]; then
echo "Image is valid, exiting."
exit 0
fi
# original sysupgrade nand did not even try to save config files, even though nand.sh worked with sysupgrade.tgz
if ask_bool $SAVE_CONFIG "Keep config files over reflash"; then
if ! mount | egrep -q "/overlay.*type.*ubifs"; then
echo "Not running on main system (upgrade or rescue), can't save configuration"
export SAVE_CONFIG=0
else
do_save_conffiles
export SAVE_CONFIG=1
fi
else
export SAVE_CONFIG=0
fi
nand_upgrade_stage2 $@
# should not be reached
exit 1
fi
type platform_check_image >/dev/null 2>/dev/null || {
echo "Firmware upgrade is not implemented for this platform."
exit 1
}
for check in $sysupgrade_image_check; do
( eval "$check \"\$ARGV\"" ) || {
if [ $FORCE -eq 1 ]; then
echo "Image check '$check' failed but --force given - will update anyway!"
break
else
echo "Image check '$check' failed."
exit 1
fi
}
done
if [ -n "$CONF_IMAGE" ]; then
case "$(get_magic_word $CONF_IMAGE cat)" in
# .gz files
1f8b) ;;
*)
echo "Invalid config file. Please use only .tar.gz files"
exit 1
;;
esac
get_image "$CONF_IMAGE" "cat" > "$CONF_TAR"
export SAVE_CONFIG=1
elif ask_bool $SAVE_CONFIG "Keep config files over reflash"; then
[ $TEST -eq 1 ] || do_save_conffiles
export SAVE_CONFIG=1
else
export SAVE_CONFIG=0
fi
if [ $TEST -eq 1 ]; then
exit 0
fi
run_hooks "" $sysupgrade_pre_upgrade
# Some platforms/devices may want different sysupgrade process, e.g. without
# killing processes yet or calling ubus system upgrade method.
# This is needed e.g. on NAND devices where we just want to trigger stage1 at
# this point.
if [ "$SAVE_CONFIG" -eq 1 ] && type 'platform_pre_upgrade' >/dev/null 2>/dev/null; then
platform_pre_upgrade "$ARGV"
fi
ubus call system upgrade
touch /tmp/sysupgrade
if [ ! -f /tmp/failsafe ] ; then
kill_remaining TERM
sleep 3
kill_remaining KILL
fi
if [ -n "$(rootfs_type)" ]; then
v "Switching to ramdisk..."
run_ramfs '. /lib/functions.sh; include /lib/upgrade; do_upgrade'
else
do_upgrade
fi